/* 
 *
 * (c) 2006 Aubit Computing Ltd
 * 
 */

#include <stdlib.h>
#include <stdio.h>
#include <string.h>
#include "read_db.h"
//#include "decimal.h"

extern char *datefmt;
extern int verbose;



void A4GL_trim (char *s);


int A4GL_get_date (int d, int *day, int *mn, int *yr);

char *
dump_short (short val)
{
  short v;
  static char buff[255];
  v = a_ntohs (val);
  if (v == -32768)
    {
      strcpy (buff, "");
      return buff;
    }
  sprintf (buff, "%d", v);
  return buff;
}

char *
dump_date (int  val)
{
  int d;
  int m;
  int y;
  static char buff[256];
  static int dtfmt = -1;
  unsigned char *ptr;

  val = (signed) ntohl (val);
  ptr = (unsigned char *) &val;
  if (ptr[0] == 0x00 && ptr[1] == 0x00 && ptr[2] == 0x00 && ptr[3] == 0x80)
    {
      strcpy (buff, "");
      return buff;
    }
  if (val==0) {
		d=31;
		m=12;
		y=1899;
  } else {
  	A4GL_get_date (val, &d, &m, &y);
  }
  if (dtfmt == -1)
    {
      if (strcmp (datefmt, "DMY4/") == 0)
	dtfmt = 1;
      if (strcmp (datefmt, "DMY4-") == 0)
	dtfmt = 2;
      if (strcmp (datefmt, "DMY2/") == 0)
	dtfmt = 3;
      if (strcmp (datefmt, "DMY2-") == 0)
	dtfmt = 4;

      if (strcmp (datefmt, "MDY4/") == 0)
	dtfmt = 5;
      if (strcmp (datefmt, "MDY4-") == 0)
	dtfmt = 6;
      if (strcmp (datefmt, "MDY2/") == 0)
	dtfmt = 7;
      if (strcmp (datefmt, "MDY2-") == 0)
	dtfmt = 8;

      if (strcmp (datefmt, "YMD4/") == 0)
	dtfmt = 9;
      if (strcmp (datefmt, "YMD4-") == 0)
	dtfmt = 10;
      if (strcmp (datefmt, "YMD2/") == 0)
	dtfmt = 11;
      if (strcmp (datefmt, "YMD2-") == 0)
	dtfmt = 12;
    }

  switch (dtfmt)
    {
    case 1:
      sprintf (buff, "%02d/%02d/%04d", d, m, y);
      return buff;
    case 2:
      sprintf (buff, "%02d-%02d-%04d", d, m, y);
      return buff;
    case 3:
      sprintf (buff, "%02d/%02d/%02d", d, m, y % 100);
      return buff;
    case 4:
      sprintf (buff, "%02d-%02d-%02d", d, m, y % 100);
      return buff;

    case 5:
      sprintf (buff, "%02d/%02d/%04d", m, d, y);
      return buff;
    case 6:
      sprintf (buff, "%02d-%02d-%04d", m, d, y);
      return buff;
    case 7:
      sprintf (buff, "%02d/%02d/%02d", m, d, y % 100);
      return buff;
    case 8:
      sprintf (buff, "%02d-%02d-%02d", m, d, y % 100);
      return buff;

    case 9:
      sprintf (buff, "%04d/%02d/%02d", y, m, d);
      return buff;
    case 10:
      sprintf (buff, "%04d-%02d-%02d", y, m, d);
      return buff;
    case 11:
      sprintf (buff, "%02d/%02d/%02d", y % 100, m, d);
      return buff;
    case 12:
      sprintf (buff, "%02d-%02d-%02d", y % 100, m, d);
      return buff;
    }
  strcpy (buff, "");
  return buff;


}

char *
dump_double (double val)
{
  static char buff[255];
  unsigned char *ptr;
  ptr = (unsigned char *) &val;
  if (ptr[0] == 0xff &&
      ptr[1] == 0xff &&
      ptr[2] == 0xff &&
      ptr[3] == 0xff &&
      ptr[4] == 0xff && ptr[5] == 0xff && ptr[6] == 0xff && ptr[7] == 0xff)
    {
      strcpy (buff, "");
      return buff;
    }

  sprintf (buff, "%lf", val);
  return buff;
}

char *
dump_float (float val)
{
  static char buff[255];
  unsigned char *ptr;
  int a;
  ptr = (unsigned char *) &val;
  if (ptr[0] == 0xff && ptr[1] == 0xff && ptr[2] == 0xff && ptr[3] == 0xff)
    {
      strcpy (buff, "");
      return buff;
    }

  sprintf (buff, "%f", val);
  return buff;
}

char *
dump_hex (char val)
{
  static char buff[255];
  sprintf (buff, "%x", val);
  return buff;
}

char *
dump_long (int  val)
{
  static char buff[255];
  unsigned char *ptr;
  val = (signed) ntohl (val);
  ptr = (unsigned char *) &val;
  if (ptr[0] == 0x00 && ptr[1] == 0x00 && ptr[2] == 0x00 && ptr[3] == 0x80)
    {
      strcpy (buff, "");
      return buff;
    }

  sprintf (buff, "%d", val);
  return buff;
}


char *
dump_decimal (char *ptr, int len, int optimize)
{
  int p;
  int a;
  int a1;
  int a2;
  int e;
  int m;
  int e1;
  int e2;
  int e3 = 0;
  int printed = 0;
  static char buff[255];
  char buffer[64];
  char sbuff[3];
  int dp = 0;
  static char zero[] = "0.0";
  p = ptr[0];

  if (p & 0x80)
    {
      strcpy (buffer, "");
    }
  else
    {
      strcpy (buffer, "-");
    }

  if (((unsigned char) ptr[0] == 0x80) && (ptr[1] == 0x0))
    {
	if (verbose>=3) { printf("Found zero\n"); }
        return zero;
    }

  e1 = p & 0x80;
  if (e1)
    e1 = 1;
  else
    e1 = 0;


  e2 = p & 0x7f;
  if (e1 == 0 && e2 != 0)
    {
      e2 = 0x7f - e2;
    }


  if (e2 != 0)
    {
      e2 = e2 - 64;
      if (e2 < 0)
	{
	  printed = 1;
	  strcat (buffer, "0.");
	  dp = 1;
	  while (e2 < 0)
	    {
	      strcat (buffer, "00");
	      e2++;
	    }
	}
    }


  if (verbose>=4) { printf("e1=%d e2=%d\n",e1,e2); }
  if (e2==0 &&dp==0) {strcat(buffer,"0."); dp=1; printed = 1;}

  if (e1 == 0)
    {
      for (a = 1; a < acl_rtypesize (5, len); a++)
        {
          if (ptr[a] != 0)
            e3 = a;
        }
    }

  for (a = 1; a < acl_rtypesize (5, len); a++)
    {


      if (e1 == 0)
	{
	  if (a == e3)
	    {
	      ptr[a] = 100 - ptr[a];
	    }
	  else if (a < e3)
	    {
	      ptr[a] = 99 - ptr[a];
	    }
	}


      if (printed || optimize == 0)
	{
	  sprintf (sbuff, "%02d", ptr[a]);
	}
      else
	{
	  sprintf (sbuff, "%d", ptr[a]);
	  printed = 1;
	}


      strcat (buffer, sbuff);
      if (a == e2)
	{
	  strcat (buffer, ".");
	  dp = 1;
	}
    }


  if (verbose>=4) { printf("Buffer=%s\n",buffer); }

  if (optimize)
    {

      if (dp)
	{
	  for (a = strlen (buffer) - 1; a > 0; a--)
	    {
	      if (buffer[a] != '0' && buffer[a] != '.')
		break;
	      if (buffer[a] == '.')
		{
		  strcat (buffer, "0");
		  break;
		}
	      buffer[a] = 0;

	    }
	}
    }

  if (buffer[0] == '-' && buffer[1] == '0' && buffer[2] == '0') {
    strcpy (buffer, "");
  }
  if (strcmp(buffer,"-0.0")==0) {strcpy(buffer,""); /* Its really null */ }

  strcpy (buff, buffer);
  if (verbose>=3) { printf("dump decimal : %s\n",buff); }
 
  return buff;
}


void
strccat (char *s, char c)
{
  char b[2];
  b[1] = 0;
  b[0] = c;
  strcat (s, b);
}

char *
dump_datetime (char *ptr, int l)
{
  static char buff[256];
  char buff2[256];
  char *x;
  int s;
  int e;
  int a;
  strcpy (buff2, dump_decimal (ptr, l, 0));
  if (buff2[0]=='-') { // Negative datetime ?
      strcpy (buff, "");
      return buff;
  }

  if (strlen (buff2) == 0)
    {
      strcpy (buff, "");
      return buff;
    }
  l = l & 0xff;
  s = l >> 4;
  e = (l & 15) + 2;
  x = &buff2[0];

  strcpy (buff, "");
  a = s;


  if (a == 0 && a < e)
    {				//Y
      strccat (buff, *x++);
      strccat (buff, *x++);
      strccat (buff, *x++);
      strccat (buff, *x++);
      a += 2;
      if (a < e)
	strccat (buff, '-');
    }

  if (a == 2 && a < e)
    {				//M
      strccat (buff, *x++);
      strccat (buff, *x++);
      a += 2;
      if (a < e)
	strccat (buff, '-');
    }

  if (a == 4 && a < e)
    {				//D
      strccat (buff, *x++);
      strccat (buff, *x++);
      a += 2;
      if (a < e)
	strccat (buff, ' ');
    }


  if (a == 6 && a < e)
    {				//h
      strccat (buff, *x++);
      strccat (buff, *x++);
      a += 2;
      if (a < e)
	strccat (buff, ':');
    }

  if (a == 8 && a < e)
    {				//m
      strccat (buff, *x++);
      strccat (buff, *x++);
      a += 2;
      if (a < e)
	strccat (buff, ':');
    }

  if (a == 10 && a < e)
    {				//s
      strccat (buff, *x++);
      strccat (buff, *x++);
      a += 2;
      if (a < e)
	strccat (buff, '.');
      if (*x == '.')
	x++;
    }

  if (a == 11 && a < e)
    {
      strccat (buff, *x++);
      a++;
    }
  if (a == 12 && a < e)
    {
      strccat (buff, *x++);
      a++;
    }
  if (a == 13 && a < e)
    {
      strccat (buff, *x++);
      a++;
    }
  if (a == 14 && a < e)
    {
      strccat (buff, *x++);
      a++;
    }
  if (a == 15 && a < e)
    {
      strccat (buff, *x++);
      a++;
    }




  return buff;
}


char *
dump_string (char *val, int l)
{
  static char *buff = 0;
  static int buff_len = 0;

  if (strchr(val,'\\')) {
		int nl;
		int a;
		int b;
		nl=l*2;
      		buff = realloc (buff, nl + 2);
		memset (buff, 0, nl + 1);
      		buff_len = nl;
		b=0;
		for (a=0;a<l;a++) {
			buff[b++]=val[a];
			if (val[a]=='\\') buff[b++]='\\';
		}
		return buff;
  }

  if (buff_len < l)
    {
	if (l>=10) {
      		buff = realloc (buff, l + 2);
      		buff_len = l;
	} else {
      		buff = realloc (buff,20);
      		buff_len = 9;
	}
    }
  memset (buff, 0, l + 1);
  memcpy (buff, val, l);
  buff[l + 1] = 0;

  return buff;
}



char *
dump_data_i (char *ptr, int dtype, int len)
{
  static char buff[30];
  switch (dtype)
    {
    case 0:
      return dump_string (ptr, len);
      break;
    case 1:
      return dump_short (*(short *) ptr);
      break;

    case 2:
    case 6:
      return dump_long (*(int *) ptr);
      break;
    case 3:
      return dump_double (*(double *) ptr);
      break;
    case 4:
      return dump_float (*(float *) ptr);
      break;
    case 5:
      return dump_decimal (ptr, len, 1);
      break;
    case 7:
      return dump_date (*(int *) ptr);
      break;
    case 10:
      return dump_datetime (ptr, len);
      break;
    default:
      sprintf (buff, "? (%d,%d)", dtype, len);
      return buff;
    }
}


char *
dump_data (char *ptr, int dtype, int len)
{
  char *r;
  r = dump_data_i (ptr, dtype, len);
  A4GL_trim (r);
  return r;
}
