/* 
 *
 * (c) 2006 Aubit Computing Ltd
 * 
 */

#include <stdio.h>		/* for printf */
#include <stdlib.h>		/* for exit */
#include <getopt.h>
#include <string.h>
#include <sys/types.h>
#include <unistd.h>

#include "go.h"
#include "read_db.h"


char search_tablename[64] = "";
char insert_tablename[64] = "";
char datefmt_s[10] = "DMY4/";
char *datefmt;
char datafile[64] = "";
int show_schema=0;
char columnfile[64] = "";
int verbose=0;
char outfile[256] = "-";
int clear_first = 0;
//char insert_tabname[64]="";
char dbname[64]="";
char uname[64] = "";
char passwd[64] = "";
int search_tabid = 0;
char mode = 'S';

int progress_type='N';
int progress_cnt=0;
int progress_max_cnt=0;


int
process_argv (int argc, char **argv)
{
  int c;

  while (1)
    {
      int this_option_optind = optind ? optind : 1;
      int option_index = 0;
      static struct option long_options[] = {
	{"tablename", 1, 0, 't'},
	{"datafile", 1, 0, 'D'},
	{"columnfile", 1, 0, 'C'},
	{"output", 1, 0, 'o'},
	{"password", 1, 0, 'p'},
	{"username", 1, 0, 'u'},
	{"verbose", 2, 0, 'v'},
	{"dbname", 1, 0, 'd'},
	{"tabid", 1, 0, 'T'},
	{"help", 0, 0, '?'},
	{"schema", 0, 0, 'Q'},
	{"dateformat", 1, 0, 'F'},
	{"insertwithcolname", 2, 0, 'I'},
	{"insert", 2, 0, 'i'},
	{"screenlisting", 0, 0, 'S'},
	{"postgres", 2, 0, 'P'},
	{"progress", 2, 0, 'G'},
	{"clear", 0, 0, 'c'},
	{"unload", 0, 0, 'U'},
	{"load", 2, 0, 'L'},
	{0, 0, 0, 0}
      };

      c = getopt_long (argc, argv, "?t:D:C:o:p:u:v:d:T:F:I:i:SP:QcUG:L:", long_options, &option_index);
      if (c == -1)
	break;

      switch (c)
	{
	//case 0:
	  //printf ("option %s", long_options[option_index].name);
	  //if (optarg)
	    //printf (" with arg %s", optarg);
	  //printf ("\n");
	  //break;

	case 't':
	  strcpy (search_tablename, optarg);
	  if (strlen (insert_tablename) == 0)
	    {
	      strcpy (insert_tablename, search_tablename);
	    }
	  break;


	case 'D':
	  strcpy (datafile, optarg);
	  break;

	case 'C':
	  strcpy (columnfile, optarg);
	  break;

	case 'o':
	  strcpy (outfile, optarg);
	  break;

	case 'p':
	  strcpy (passwd, optarg);
	  break;

	case 'u':
	  strcpy (uname, optarg);
	  break;

	case 'v':
	  verbose = 1;
	  if (optarg)
	    verbose = atoi (optarg);
	  break;

	case 'd':
	  strcpy (dbname, optarg);
	  break;

	case 'G':
		progress_type=0;
		if (optarg[0]=='%') { progress_type='%';}
		if (optarg[0]=='1') { progress_type='1';}
		if (optarg[0]=='2') { progress_type='2';}
		if (optarg[0]=='3') { progress_type='3';}
		if (optarg[0]=='4') { progress_type='4';}
		if (optarg[0]=='5') { progress_type='5';}
		if (optarg[0]=='6') { progress_type='6';}
		if (optarg[0]=='N') { progress_type='N';}
		if (progress_type==0) {
			fprintf(stderr,"Invalid progress flag type - Use %%123456 or N for none\n");
			exit(2);
		}
	
	  break;


	case 'T':
	  search_tabid = atoi (optarg);
	  if (search_tabid == 0)
	    {
	      printf ("TABID doesn't seem to be a number\n");
	      return -1;
	    }
          break;

	case 'F':
	  strcpy (datefmt, optarg);
	  check_datefmt ();
	  break;

	case 'I':
	  mode = 'I';
	  if (optarg)
	    strcpy (insert_tablename, optarg);
	  break;

	case 'i':
	  mode = 'i';
	  if (optarg)
	    strcpy (insert_tablename, optarg);
	  break;

	case 'S':
	  mode = 'S';
	  break;

	case 'P':
	  mode = 'P';
	  if (optarg)
	    strcpy (insert_tablename, optarg);
	  break;

	case 'c':
	  clear_first = 1;
	  break;
	case 'Q':
	  show_schema = 1;
	  break;

	case 'U':
	  mode = 'U';
	  break;

	case 'L':

	  mode = 'u';

	  if (optarg) strcpy (insert_tablename, optarg);
	  if (strlen(outfile)==0||strcmp(outfile,"-")==0) { sprintf(outfile,"/tmp/unlfile_%d",getpid()); }

	  break;

	case '?':
	  return 0;
	default:
	  return -1;
	}
    }

  if (optind < argc)
    {
      return -1;
    }



// Saninty  check
  if (strlen (insert_tablename) == 0)
    {
      if (mode == 'I' || mode == 'P' || mode == 'i')
	{
	  printf ("you must specify a table name\n");
	  return -1;
	}
    }


  if (strlen(datafile)>0 && strlen(columnfile)==0) {
		printf("Must specify a column file when reading a .dat directly\n");
		return -1;
  }

  if (search_tabid <= 0 && strlen (search_tablename) == 0 && strlen(datafile)==0)
    {
      printf ("Warnig: No tablename, tabid or .dat file specified\n");
      return -1;
    }

  if (strlen(dbname)||strlen(uname)||strlen(passwd)) {
	if (mode!='P'&&mode!='u') {
		printf("database/username or password specified when not writing to a database\n");
		return -1;
	}
  }

  if (clear_first&&(mode!='P'&&mode!='u')) {
		printf("clearfirst can only be used with --postgres or --load\n");
		return -1;
  }

if (verbose>=2) {
	printf("search_tablename=%s\n", search_tablename);
	printf("insert_tablename=%s\n", insert_tablename);
	printf("datefmt         =%s\n", datefmt);
	printf("datafile        =%s\n", datafile);
	printf("columnfile      =%s\n", columnfile);
	printf("verbose         =%d\n", verbose);
	printf("outfile         =%s\n", outfile);
	printf("clear_first     =%d\n", clear_first);
	printf("insert_tabname  =%s\n", insert_tablename);
	printf("dbname          =%s\n", dbname);
	printf("uname           =%s\n", uname);
	printf("passwd          =%s\n", passwd);
	printf("search_tabid    =%d\n", search_tabid );
	printf("mode            =%c\n", mode);
}


  return 1;
}







void
usage (char *myname,int exitcode)
{

	printf("Usage :\n");
	printf("%s -?|--help\n",myname);
	printf("%s -t <tabname>|--tablename=<tabname> [options]     Look for tabname in systables\n",myname);
	printf("%s -T <tabid>|--tabid=<tabid> [options]             Look for tabid in systables\n",myname);
	printf("%s -D <datafile>|--datafile=<datafile>  [options]   Use specified .dat file (requires -C)\n",myname);
	printf("\nOptions\n");
	printf("-v[n]|--verbose[=n]                       Be verbose (n=0-5)\n");
	printf("-C <columnfile>|--columnfile=<columnfile> Use/Generate a column file\n");
	printf("-o|--output                               output file name (for -I and -U) (default:stdout)\n");
	printf("-F<format>|--dateformat=<format>          Specify output date format (eg DMY4/ or MDY2-)\n");
        printf("\n");
	printf("Output Styles\n");
	printf("-I <tablename>|--insertwithcolname[=tablename] Generate Insert statements with column names\n");
	printf("-i <tablename>|--insert[=tablename]            Generate Insert statements without column names\n");
	printf("-S|--screenlisting     Generate screen listing\n");
	printf("-U|--unload            Generate an unload format file\n");
	printf("-P <tablename>|--postgres[=tablename]          Insert directly into a postgres database\n");
  	printf("         -d database [-u username] [-p password]\n");
	printf("         -c|--clear\n");
	printf("\n\n");


  exit(exitcode);
}
